Last Comment Bug 331723 - Don't kill Win98
: Don't kill Win98
Status: RESOLVED WONTFIX
: helpwanted
Product: Core Graveyard
Classification: Graveyard
Component: GFX (show other bugs)
: Trunk
: x86 Windows 98
: -- critical with 6 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
http://forums.mozillazine.org/viewtop...
Depends on:
Blocks: 330276 333221
  Show dependency treegraph
 
Reported: 2006-03-25 14:43 PST by Hermann Schwab
Modified: 2010-09-01 21:47 PDT (History)
26 users (show)
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
spam jpeg image... (123.17 KB, image/pjpeg)
2009-09-14 19:21 PDT, monicapedrosa
no flags Details

Description Hermann Schwab 2006-03-25 14:43:55 PST
Infact Firefox trunk isn't running anymore on Win9x, though "Bug 330276 Drop support for pre-Win2k platforms." hasn't been checked in yet.
From what I know from Bugzilla, Firefox is less problematic on Win9x than on WinXP, so why kill it? Simply because some new guys want to save some hundred bytes by removing old proven code? So why not kill Quirks mode also? Would also make the code more readable.
Mozilla is running on some other platforms having smaller numbers, so why kill Win98? If you want to kill it, please don't do it silently in the backyard by checking in something in the trunk, but do a survey about market shares of OS in the new installed (or updated) Firefox.

I'm marking this critical, as checkin of that other bug will break Firefox on Win9x.
Comment 1 Jungshik Shin 2006-03-25 18:35:13 PST
(In reply to comment #0)
> Infact Firefox trunk isn't running anymore on Win9x, though "Bug 330276 Drop
> support for pre-Win2k platforms." hasn't been checked in yet.

It's not working because we switched to Cairo that relies on what's not available on Win 9x/ME

> From what I know from Bugzilla, Firefox is less problematic on Win9x than on
> WinXP, so why kill it? Simply because some new guys want to save some hundred
> bytes by removing old proven code? 

No, that's just one of many reasons. There are many features of Win 2k or later that we can't use (that requires a lot of roundabout codes to support on Win 9x/ME) because we also had to support Win 9x/ME. I'm not sure whether it's a good idea to break Win 9x/ME as aggresively/intentionally as in bug 330276, but it's certainly getting harder to support Win 9x/ME (see recent comments in bug 162361 on the issue.)
Comment 2 Benoît 2006-03-29 04:28:13 PST
Features of Win2000 and later that you can't use? I don't think an open-source program that is cross-platform should rely on features of an operating system. Could as well drop Linux since its user amount pales in comparison to WinXP, and even Win9x, with this logic.
Comment 3 Benoît 2006-03-29 04:30:49 PST
Changing product to core, as this is mostly related to back-end.
Comment 4 Jungshik Shin 2006-03-29 04:49:09 PST
(In reply to comment #2)

> Features of Win2000 and later that you can't use? I don't think an open-source
> program that is cross-platform should rely on features of an operating system.

Are you serious? So, we can't even use TextOutW on Windows. What are we supposed to use to draw a text on the screen on Windows? 

> Could as well drop Linux since its user amount pales in comparison to WinXP,
> and even Win9x, with this logic.

It's not the market share but how old Win9x is. I don't think the current trunk (with its default configuration) can be built on a Linux distribution released in 1998 let alone 1995. Linux didn't have Xft, fontconfig, pango, gtk(2), iconv, a decent i18n support in glibc ... in 1995 (and most of the above were not available in 1998, either).

 

Comment 5 Masayuki Nakano [:masayuki] (Mozilla Japan) 2006-03-29 05:23:59 PST
I think that we will refactor gfx interface for nsTextFrame.
See http://weblogs.mozillazine.org/roc/archives/2006/02/post_1.html

If we don't drop the Win9x support, somebody needs to work for this.
Who can work it??

# And I think that the MS dropped the Win9x support, so the OSs are not secure.
# I don't think that Win9x support is good things...
Comment 6 u88484 2006-04-04 16:35:21 PDT
The patch was checked in today that drops support for any windows versions under Windows 2000. Bug 330276 Comment 36 explains how to custom build for those affected windows versions.

Marking this WONTFIX since this is by design for Firefox 3.0 release. (Still got over a year of support still with 2.0 and increments inbetween)
Comment 7 Kees Grinwis 2006-04-07 12:11:49 PDT
When the creator of this bug is still interested in a special version of Firefox 3.0 (which is still a year away) he can always create a "port" to Win98.

Due to the open source nature of Firefox you are still able to get the application running, when you have the necessary skills of course.

You might even be able to get the blessing of the Mozilla Foundation/Corporation in the same way as the Sea Monkey project has.
Comment 8 Hermann Schwab 2006-04-07 16:28:45 PDT
(In reply to comment #7)
> When the creator of this bug is still interested in a special version of
> Firefox 3.0 (which is still a year away) he can always create a "port" to
> Win98.

No I can't, I'm not a windows developer. 

> Due to the open source nature of Firefox you are still able to get the
> application running, when you have the necessary skills of course.

I don't have that skills, but imho that killing of Win9x has been done clandestine and hastily, also killing knowledge. At first win9x was broken, than a bug filed to 'pre-Win2k platforms'. Firefox is a consumer browser, in contrast to seamonkey which is less known in the public. Consumers don't run Win2k, they are running WinXP, or Win98SE, rarely WinME or Win95. Breaking Win98SE will disallow users to run a current Gecko on their old computers, and why should they run a browser only on their top machine, if they have one?

I'm pissed off by the unprofessional, clandestine handling of the issue.
First Win9x support is broken, don't care
Sometime later a bug is filed: Bug 330208 Unsupported windows versions need error message on startup (and in installer)
Even later another one is filed, politically correct avoiding naming the deed 
(drop life support = kill) and the victim (preWin2k = mostly Win98SE)
Bug 330276 Drop support for pre-Win2k platforms

And the this bug is resolved as WONTFIX not by a module owner, or one of the programmers involved in 'fixing' Bug 330276, no, Supernova is telling me this bug is WONTFIX because the other one has been fixed. No Sir, as offered in 
Bug 330276 Comment #36, RoC offers review if someone wants to make a shim library supporting Win9x.
Bug 330276 Comment #35, RoC mentions concerns that that checkin also removed some code supporting transparency on Win2k.

The logic of Bug 330276 Comment #32 also needs a fix:
Whoever is stupid enough to use Win9x as his primary system must have an old computer...
Using win9x implies having an old computer, that's logical, using it as primary system is not, and using the primary system (WinXP) for surfin' the internet is stupid, as Win9x is more secure on doing this. Ever tried to update a fresh installed XP over Internet? The worms are faster than the patches.

The logic of Bug 330276 Comment #33 also needs a fix:
>Win9x has been dead for a long time before this.  Microsoft EOLed 98SE the year before last...

see http://support.microsoft.com/?scid=ph;en-us;1139
End of support for Windows 98 and Windows Me
Effective July 11, 2006, ... will transition to a non-supported status.
Yes, MS had EOLed 98SE the year before, but they reenabled support...

> You are encouraging the same sorts of silly behavior that got Microsoft into its current position of having so many security problems due to leaving in things that were best removed in order to have backwards compatibility with legacy systems that a few old codgers use and no-one else.

So here I'm told from a fanboy that older Software from this place is unsecure and crap, used only by a few old codgers and noone else? He must be pretty new or pretty blind not having seen the regressions in software quality. If I'm crashing with Firefox, but not using Seamonkey or Opera, win98 is to blame?

> You might even be able to get the blessing of the Mozilla
> Foundation/Corporation in the same way as the Sea Monkey project has.

The contributors to the Seamonkey Project are the founders of Mozilla.org community and codebase, and they are still producíng a lot of code also used in Firefox. 
This bug is about a useless crappy old orphaned OS, used only by morons, old codgers, poor widows and orphans. 

I'm reopening it to free Bug 330276 from the discussion about win9x, they've broken enough besides Win9x to care about.
Maybe somebody feels fit to make a shim library like RoC suggested in Bug 330276 Comment #36
Comment 9 Ben Basson 2006-04-07 20:09:03 PDT
Win9x support isn't being "killed", Firefox is simply moving beyond the point at which it is viable to keep supporting it. Like it or not, it just doesn't have the same APIs/functionality as newer Windows versions - see comment 1 and comment 4.

Please continue in the forum discussion, this is not the purpose of Bugzilla.
Comment 10 tech 2006-04-20 02:02:02 PDT
I thought that firefox and mozilla were developped by a free non commercial software comunity... But while microsoft is  still (for two month) supporting windows 98 the mozilla team let it down...
If firefox really needed win2k api how could it work on linux ?
Comment 11 Jungshik Shin 2006-04-20 03:35:51 PDT
(In reply to comment #10)
> I thought that firefox and mozilla were developped by a free non commercial
> software comunity... But while microsoft is  still (for two month) supporting
> windows 98 the mozilla team let it down...

No, you got it wrong. Firefox 2 will support Win 9x/ME and it won't be released by June. It'll be released sometime in the 2nd half of this year when Microsfot won't support Win 98 any more. FF2 will be maintained well into next year, which means our support of Win98 will outlast that of MS. It's FF3 that won't support Win 9x/ME and FF3 will be released sometime next year.

Also, note that holding us back by insisting that we can't go ahead with this change  means that we can't effectively support hundreds of millions of people whose languages requires complex script support only available on Win 2k/XP


> If firefox really needed win2k api how could it work on linux ?

I guess you must be joking. See comment #4.

As for the compatibility layer necessary for Win 9x/ME, I guess one can contribute to/develope further/modify MZLU (see bug 162361)


Comment 12 Vladimir Vukicevic [:vlad] [:vladv] 2006-05-29 14:09:06 PDT
No released version of Firefox lacks support for Windows 98, nor will the next release of Firefox lack support for Windows 98.  Gecko 1.9, the basis for a a version of Firefox to be released sometime next year, will not have support for Windows 98, ME, or NT; this was announced in various developer forums.
Comment 13 Gervase Markham [:gerv] 2006-06-09 05:18:23 PDT
Those involved in this bug may be interested in my blogpost on the subject:
http://weblogs.mozillazine.org/gerv/archives/2006/06/drop_windows_9xme_support.html

Gerv
Comment 14 Damian Yerrick 2006-06-09 21:40:57 PDT
"Complex script support": Does this mean Firefox will finally get dynamic fonts, which are necessary to support scripts that are not in Unicode?
Comment 15 Stanimir Stamenkov 2006-06-10 04:27:37 PDT
Out of curiosity - which are those scripts "not in Unicode"? The point is to support Unicode natively using the OS support. The "dynamic fonts" is completely different beast and given Gecko provides nice "font substitution" capability for characters, glyphs for which are not available in the current font - I don't think there's a better thing a man can get (IE is full crap in this respect, if you have enough experience with it).
Comment 16 Gábor Stefanik 2006-06-18 07:02:48 PDT
Actually I doubt that there is any way of keeping Win98 support when we want the Windows version of Firefox to be a Windows Vista-era program. (Can anybody send me the link to WinFX for DOS?! :D ) So, there is no point to keep support for Win98, as that would prevent the usage of the new APIs coming in Windows Vista. (Do we want Vista disable it's new user interface and go int legacy mode everytime Firefox is started, insted of dropping Win98 support?)
Comment 17 Hermann Schwab 2006-06-18 08:46:31 PDT
(In reply to comment #16)
> So, there is no point to keep support
> for Win98, as that would prevent the usage of the new APIs coming in Windows
> Vista. 

So you also must remove the support of WindowsXP and Windows2k as they also don't support the new APIs of Vista. Besides, currently the Market share of Win98 is way higher than that of a not yet released Vista ;-)


Comment 18 Stanimir Stamenkov 2006-06-18 09:08:32 PDT
IIRC the Unicode APIs are ever since WinNT 3.51, i.e. WinNT 4.0/Win2000 (WinNT 5.0)/WinXP (WinNT 5.1) all have the required support. No Vista specific APIs are needed.

The only WinXP specific (which will be used the same with Vista) thing I know of is the support for the Windows Visual Styles which is handled inside the Gecko "native appearance" engine but that's implemented specific to any other than Windows OS and is not required to have fully functional application.
Comment 19 Mardeg 2008-04-17 00:39:09 PDT
A project that has Firefox 3 beta 5 working in windows 98SE is at http://www.msfn.org/board/UberKern-t115731.html
Comment 20 Ryan S. Scheel [:havvy] 2008-04-26 14:28:18 PDT
I got it to work for a few minutes...

I'll explain how if I can get it to work once again...
Comment 21 Ryan S. Scheel [:havvy] 2008-04-27 17:17:15 PDT
Alright, well, it works, but you can't use the -p and -no-remote flags.

Here is what you do:  (Also works for Windows ME)

Install the following four things:

1.  Make sure you have the Unicows.dll file downloaded.  If not, download at http://www.microsoft.com/downloads/details.aspx?FamilyId=73BA7BD7-ED06-4F0D-80A4-2A7EEAEE17E2&displaylang=en and when asked to install, put it in C:\Windows\System\ .  If you don't get it you'll get an error with the next thing you have to install.

2a.  Download the KernelEx file (I used 0.3.3e, not sure if future versions will work, though they probably with).  File is at:  http://www.msfn.org/board/KernelEx-v033e-released-t71476.html&st=900#entry757714  Follow the install instructions.

2b.  Create the following file:  C:\WINDOWS\KEXVER.INI and put in it 

[PerApp]
Firefox Setup 3.0 Beta 5.exe=win2000

3.  Download and run the Fx3 (I used fx3b5) installer and do that.

4.  Download Uberkern at http://www.msfn.org/board/UberKern-t115731.html&s=aa84bf6c93d9050d285b0590259625a8
and put the zip files in Fx3 folder.  Then take the XUL.dll file and put it into the .exe that comes with Uberkern.  It's say "Mabey Okay" or something like that, and it should be good.

Remember:  At the moment, flags are not working such as -p and -no-remote.  Those cause crashes...
Comment 22 Mardeg 2009-08-20 22:21:55 PDT
For step 2a the new link is at http://www.msfn.org/board/kernelex-4-0-final-t130936.html
Comment 23 monicapedrosa 2009-09-14 19:21:12 PDT
Created attachment 400654 [details]
spam jpeg image...
Comment 24 Jim K 2010-09-01 15:04:30 PDT
So I'm one of the "morons, old codgers, poor widows and orphans who use a useless **** old orphaned OS", eh?

I've been computing since 1970 (including writing the odd bit of software) and I'm now as a pensioner living at around the UK poverty line. Win98 does what I need without all the extra junk that's foisted on MS users who can afford the time and money for the continual repair of their latest laceware. 

I'm not demanding full backwards compatibility with every new issue of FF but at least provide a source for older versions for those of us who don't want the new APIs. And if somebody finds a way around the API block, then great - let's have access to it.

Having happily used Netscape almost from its birth, I find these sorts of comments ("morons, old codgers, poor widows and orphans") rude and arrogant in the extreme: show some respect for your users whoever they are.

Note You need to log in before you can comment on or make changes to this bug.